#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK1x28x28NT1x1x1_aX_b1
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=1, NB=28, KB=28, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=1, pf=513
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   const float *stM = A + 1;
   const float *stN = B + 28;
   const float *pfA = A + lda*M;
   const float BetaAlpha = beta / alpha;
   const int incAk = (lda);
   const int incAm = 1 - (28*(lda)), incAn = -1;
   const int incBk = (ldb), incBm = -(28*(ldb));
   #define incBn 1
   #define incCm 1
   const int incCn = (ldc) - 1;
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float rC0_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      pfA += lda;
      rA0 = BetaAlpha;
      rC0_0 = *pC0;
      rC0_0 *= rA0;
      for (k=28; k; k--) /* easy loop to unroll */
      {
         rA0 = *pA0;
         rB0 = *pB0;
         rC0_0 += rA0 * rB0;
         pA0 += incAk;
         pB0 += incBk;
      }
      rB0 = alpha;
      rC0_0 *= rB0;
      *pC0 = rC0_0;
      pC0 += incCm;
      pA0 += incAm;
      pB0 += incBm;
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_sJIK28x28x28NT0x0x0_aX_b1
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=28, NB=28, KB=28, 
 * lda=0, ldb=0, ldc=0, mu=3, nu=1, ku=1, pf=513
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + 27;
   const float *stN = B + 28;
   const float *pfA = A + lda*M;
   const float BetaAlpha = beta / alpha;
   const int incAk = (lda);
   const int incAm = 3 - (28*(lda)), incAn = -27;
   const int incBk = (ldb), incBm = -(28*(ldb));
   #define incBn 1
   #define incCm 3
   const int incCn = (ldc) - 27;
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2;
   register float rB0;
   register float rC0_0, rC1_0, rC2_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC1_0 = pC0[1];
         rC1_0 *= rA0;
         rC2_0 = pC0[2];
         rC2_0 *= rA0;
         for (k=28; k; k--) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[1];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[2];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         rB0 = alpha;
         rC0_0 *= rB0;
         rC1_0 *= rB0;
         rC2_0 *= rB0;
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
   ATL_sJIK1x28x28NT1x1x1_aX_b1(1, 28, 28, alpha, ca + 27, lda, cb, ldb, beta, cc + 27, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
